fix(bkgpslog):Fix pubkey strings with spaces
[EVA-2020-02.git] / exec / bkgpslog
index bd77ffd900faab2800b95cc6546fa885c84697ed..50b83dcb6a5c382501bfcc9bb376d25fa4d82f43 100755 (executable)
@@ -2,18 +2,32 @@
 
 # Desc: Records gps data until midnight
 # Author: Steven Baltakatei Sandoval; License: GPLv3+
-# Usage: bkgpslog --output [output dir]
+# Usage: bkgpslog -o [output dir]
 
 #==BEGIN Define script parameters==
-PATH="/opt/bktei:$PATH"         # Add default baltakatei script install directory to PATH (necessary for other bk scripts)
-SCRIPT_HOSTNAME=$(hostname)     # Save hostname of system running this script.
-SCRIPT_VERSION="bkgpslog 0.0.1" # Define version of script.
-SCRIPT_TIME_SHORT="$(date +%Y%m%dT%H%M%S%z)" # Save current date & time in ISO-8601 format.
-SCRIPT_DATE_SHORT="$(date +%Y%m%d)"          # Save current date in ISO-8601 format.
+## Logging Behavior parameters
+BUFFER_TTL="300"; # time between file writes
+SCRIPT_TTL="day"; # (day|hour)
+#### TZ="UTC"; export TZ; # Default time zone; overridden by '--time-zone=[str]' option
+DIR_TMP_DEFAULT="/dev/shm"; # Default parent of working directory
+
+SCRIPT_TIME_START=$(date +%Y%m%dT%H%M%S.%N);
+PATH="$HOME/.local/bin:$PATH";   # Add "$(systemd-path user-binaries)" path in case apps saved there
+SCRIPT_HOSTNAME=$(hostname);     # Save hostname of system running this script.
+SCRIPT_VERSION="0.3.6";          # Define version of script.
+SCRIPT_NAME="bkgpslog";          # Define basename of script file.
+SCRIPT_URL="https://gitlab.com/baltakatei/ninfacyzga-01"; # Define wesite hosting this script.
+AGE_VERSION="1.0.0-beta2";       # Define version of age (encryption program)
+AGE_URL="https://github.com/FiloSottile/age/releases/tag/v1.0.0-beta2"; # Define website hosting age.
 
 declare -Ag appRollCall # Associative array for storing app status
 declare -Ag fileRollCall # Associative array for storing file status
 declare -Ag dirRollCall # Associative array for storing dir status
+declare -a recPubKeys # for processArguments function
+declare recipients # for main function
+
+## Initialize variables
+OPTION_VERBOSE=""; OPTION_ENCRYPT=""; OPTION_COMPRESS=""; OPTION_TMPDIR="";
 
 #===BEGIN Declare local script functions===
 checkapp() {
@@ -140,8 +154,31 @@ showUsage() {
     echoerr "    -v, --verbose"
     echoerr "            Display debugging info."
     echoerr
+    echoerr "    -e, --encrypt"
+    echoerr "            Encrypt output."
+    echoerr
+    echoerr "    -r, --recipient [ pubkey string ]"
+    echoerr "            Specify recipient. May be age or ssh pubkey."
+    echoerr "            See https://github.com/FiloSottile/age"
+    echoerr
     echoerr "    -o, --output [ directory ]"
     echoerr "            Specify output directory to save logs."
+    echoerr
+    echoerr "    -c, --compress"
+    echoerr "            Compress output with gzip (before encryption if enabled)."
+    echoerr
+    echoerr "    -z, --time-zone"
+    echoerr "            Specify time zone. (ex: \"America/New_York\")"
+    echoerr
+    echoerr "    -t, --temp-dir"
+    echoerr "            Specify parent directory for temporary working directory."
+    echoerr "            Default: \"/dev/shm\""
+    echoerr
+    echoerr "EXAMPLE: (bash script lines)"
+    echoerr "/bin/bash bkgpslog -e -c \\"
+    echoerr "-r age1mrmfnwhtlprn4jquex0ukmwcm7y2nxlphuzgsgv8ew2k9mewy3rs8u7su5 \\"
+    echoerr "-r age1ala848kqrvxc88rzaauc6vc5v0fqrvef9dxyk79m0vjea3hagclswu0lgq \\"
+    echoerr "-o ~/Sync/Location"
 } # Display information on how to use this script.
 showVersion() {
     echoerr "$SCRIPT_VERSION"
@@ -170,93 +207,800 @@ vbm() {
 } # Verbose message display function.
 processArguments() {
     while [ ! $# -eq 0 ]; do   # While number of arguments ($#) is not (!) equal to (-eq) zero (0).
-       echoerr "DEBUG:Starting processArguments while loop."
-       echoerr "DEBUG:Provided arguments are:""$*"
+       #echoerr "DEBUG:Starting processArguments while loop."
+       #echoerr "DEBUG:Provided arguments are:""$*"
        case "$1" in
-           --h | --help) showUsage; exit 1;; # Display usage.
+           -h | --help) showUsage; exit 1;; # Display usage.
            --version) showVersion; exit 1;; # Show version
-           --v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
-           --o | --output) if [ -d "$2" ]; then DIROUT="$2"; vbm "DEBUG:DIROUT:$DIROUT"; shift; fi ;; # Define output directory.
-           *) echoerr "ERROR: Unrecognized argument."; exit 1;; # Handle unrecognized options.
+           -v | --verbose) OPTION_VERBOSE="true"; vbm "DEBUG:Verbose mode enabled.";; # Enable verbose mode.
+           -o | --output) if [ -d "$2" ]; then DIR_OUT="$2"; vbm "DEBUG:DIR_OUT:$DIR_OUT"; shift; fi ;; # Define output directory.
+           -e | --encrypt) OPTION_ENCRYPT="true"; vbm "DEBUG:Encrypted output mode enabled.";;
+           -r | --recipient) # Add 'age' recipient via public key string
+               recPubKeys+=("$2"); vbm "STATUS:pubkey added:""$2"; shift;;
+           -c | --compress) OPTION_COMPRESS="true"; vbm "DEBUG:Compressed output mode enabled.";;
+           -z | --time-zone) try setTimeZoneEV "$2"; shift;;
+           -t | --temp-dir) OPTION_TMPDIR="true" && TMP_DIR_PRIORITY="$2"; shift;;
+           *) echoerr "ERROR: Unrecognized argument: $1"; echoerr "STATUS:All arguments:$*"; exit 1;; # Handle unrecognized options.
        esac
        shift
     done
 } # Argument Processing
-timeUntilMidnight(){
-    # Desc: Report seconds until midnight
-    # Output: stdout: integer seconds until midnight
+setTimeZoneEV(){
+    # Desc: Set time zone environment variable TZ
+    # Usage: setTimeZoneEV arg1
+    # Input: arg1: 'date'-compatible timezone string (ex: "America/New_York")
+    #        TZDIR env var (optional; default: "/usr/share/zoneinfo")
+    # Output: exports TZ
+    #         exit code 0 on success
+    #         exit code 1 on incorrect number of arguments
+    #         exit code 2 if unable to validate arg1
+    # Depends: yell, printenv, bash 5
+    # Tested on: Debian 10
+    ARG1="$1"
+    local tzDir returnState
+    if ! [[ $# -eq 1 ]]; then
+       yell "ERROR:Invalid argument count.";
+       return 1;
+    fi
+
+    # Read TZDIR env var if available
+    if printenv TZDIR 1>/dev/null 2>&1; then
+       tzDir="$(printenv TZDIR)";
+    else
+       tzDir="/usr/share/zoneinfo";
+    fi
+    
+    # Validate TZ string
+    if ! [[ -f "$tzDir"/"$ARG1" ]]; then
+       yell "ERROR:Invalid time zone argument.";
+       return 2;
+    else
+    # Export ARG1 as TZ environment variable
+       TZ="$ARG1" && export TZ && returnState="true";
+    fi
+
+    # Determine function return code
+    if [ "$returnState" = "true" ]; then
+       return 0;
+    fi
+} # Exports TZ environment variable
+timeUntilNextDay(){
+    # Desc: Report seconds until next day.
+    # Version: 1.0.0
+    # Output: stdout: integer seconds until next day
     # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
-    # Usage: timeUntilMidnight
-    # Usage: if ! myTTL="$(timeUntilMidnight)"; then yell "ERROR in if statement"; exit 1; fi
-    local returnState
+    # Usage: timeUntilNextDay
+    # Usage: if ! myTTL="$(timeUntilNextDay)"; then yell "ERROR in if statement"; exit 1; fi
+    # Depends: date 8, echo 8, yell, try
+    
+    local returnState TIME_CURRENT TIME_NEXT_DAY SECONDS_UNTIL_NEXT_DAY
+
     TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)" # Produce separator-less current timestamp with resolution 1 second.
-    DATE_CURRENT="$(date -d "$TIME_CURRENT" --iso-8601=date)" ; # Produce `date`-parsable current timestamp with resolution of 1 day.
-    DATE_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%d)" ; # Produce separator-less current timestamp with resolution 1 day.
-    DATE_TOMORROW="$(date -d "$TIME_CURRENT next day" --iso-8601=date)" ; # Produce timestamp of tomorrow's date (res. 1 day).
-    TIME_NEXT_MIDNIGHT="$(date -d "$DATE_TOMORROW" --iso-8601=seconds)" ; # Produce `date`-parsable timestamp of closest future midnight (res. 1 second).
-    SECONDS_UNTIL_NEXT_MIDNIGHT="$(( $(date +%s -d "$TIME_NEXT_MIDNIGHT") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
-    if [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -gt 0 ]]; then
+    TIME_NEXT_DAY="$(date -d "$TIME_CURRENT next day" --iso-8601=date)"; # Produce timestamp of beginning of tomorrow with resolution of 1 second.
+    SECONDS_UNTIL_NEXT_DAY="$(( $(date +%s -d "$TIME_NEXT_DAY") - $(date +%s -d "$TIME_CURRENT") ))" ; # Calculate seconds until closest future midnight (res. 1 second).
+    if [[ "$SECONDS_UNTIL_NEXT_DAY" -gt 0 ]]; then
        returnState="true";
-    elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -eq 0 ]]; then
-       returnState="WARNING_ZERO";
-       yell "WARNING:Reported time until midnight exactly zero.";
-    elif [[ "$SECONDS_UNTIL_NEXT_MIDNIGHT" -lt 0 ]]; then
-       returnState="WARNING_NEGATIVE";
-       yell "WARNING:Reported time until midnight is negative.";
+    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -eq 0 ]]; then
+       returnState="warning_zero";
+       yell "WARNING:Reported time until next day exactly zero.";
+    elif [[ "$SECONDS_UNTIL_NEXT_DAY" -lt 0 ]]; then
+       returnState="warning_negative";
+       yell "WARNING:Reported time until next day is negative.";
     fi
 
-    try echo "$SECONDS_UNTIL_NEXT_MIDNIGHT"; # Report
+    try echo "$SECONDS_UNTIL_NEXT_DAY"; # Report
     
-    #===Determine function return code===
+    # Determine function return code
+    if [[ "$returnState" = "true" ]]; then
+       return 0;
+    elif [[ "$returnState" = "warning_zero" ]]; then
+       return 1;
+    elif [[ "$returnState" = "warning_negative" ]]; then
+       return 2;
+    fi
+} # Report seconds until next day
+timeUntilNextHour(){
+    # Desc: Report seconds until next hour
+    # Version 1.0.0
+    # Output: stdout: integer seconds until next hour
+    # Output: exit code 0 if stdout > 0; 1 if stdout = 0; 2 if stdout < 0
+    # Usage: timeUntilNextHour
+    # Usage: if ! myTTL="$(timeUntilNextHour)"; then yell "ERROR in if statement"; exit 1; fi
+    
+    local returnState TIME_CURRENT TIME_NEXT_HOUR SECONDS_UNTIL_NEXT_HOUR
+    TIME_CURRENT="$(date --iso-8601=seconds)"; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    TIME_NEXT_HOUR="$(date -d "$TIME_CURRENT next hour" --iso-8601=hours)"; # Produce `date`-parsable current time stamp with resolution of 1 second.
+    SECONDS_UNTIL_NEXT_HOUR="$(( $(date +%s -d "$TIME_NEXT_HOUR") - $(date +%s -d "$TIME_CURRENT") ))"; # Calculate seconds until next hour (res. 1 second).
+    if [[ "$SECONDS_UNTIL_NEXT_HOUR" -gt 0 ]]; then
+       returnState="true";
+    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -eq 0 ]]; then
+       returnState="warning_zero";
+       yell "WARNING:Reported time until next hour exactly zero.";
+    elif [[ "$SECONDS_UNTIL_NEXT_HOUR" -lt 0 ]]; then
+       returnState="warning_negative";
+       yell "WARNING:Reported time until next hour is negative.";
+    fi
+
+    try echo "$SECONDS_UNTIL_NEXT_HOUR"; # Report
+    
+    # Determine function return code
     if [[ "$returnState" = "true" ]]; then
        return 0;
-    elif [[ "$returnState" = "WARNING_ZERO" ]]; then
+    elif [[ "$returnState" = "warning_zero" ]]; then
        return 1;
-    elif [[ "$returnState" = "WARNING_NEGATIVE" ]]; then
+    elif [[ "$returnState" = "warning_negative" ]]; then
        return 2;
     fi
-} # Report seconds until next midnight
+} # Report seconds until next hour
 dateTimeShort(){
     # Desc: Timestamp without separators (YYYYmmddTHHMMSS+zzzz)
-    # Usage: dateTimeShort
+    # Usage: dateTimeShort ([str date])
+    # Version 1.1.0
+    # Input: arg1: 'date'-parsable timestamp string (optional)
     # Output: stdout: timestamp (ISO-8601, no separators)
+    # Depends: yell
+    local TIME_CURRENT TIME_CURRENT_SHORT
+
+    argTime="$1";
+    # Get Current Time
     TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
-    TIME_CURRENT_SHORT="$(date -d "$TIME_CURRENT" +%Y%m%dT%H%M%S%z)"; # Produce separator-less current timestamp with resolution 1 second.
+    # Decide to parse current or supplied date
+    ## Check if time argument empty
+    if [[ -z "$argTime" ]]; then
+       ## T: Time argument empty, use current time
+       TIME_INPUT="$TIME_CURRENT";
+    else
+       ## F: Time argument exists, validate time
+       if date --date="$argTime" 1>/dev/null 2>&1; then
+           ### T: Time argument is valid; use it
+           TIME_INPUT="$argTime";
+       else
+           ### F: Time argument not valid; exit
+           yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+       fi
+    fi
+    # Construct and deliver separator-les date string
+    TIME_CURRENT_SHORT="$(date -d "$TIME_INPUT" +%Y%m%dT%H%M%S%z)";
     echo "$TIME_CURRENT_SHORT";
-} # Get date&time without separators
+} # Get YYYYmmddTHHMMSS±zzzz
+dateShort(){
+    # Desc: Date without separators (YYYYmmdd)
+    # Usage: dateShort ([str date])
+    # Version: 1.1.0
+    # Input: arg1: 'date'-parsable timestamp string (optional)
+    # Output: stdout: date (ISO-8601, no separators)
+    # Depends: yell
+    local TIME_CURRENT DATE_CURRENT_SHORT
+
+    argTime="$1";
+    # Get Current Time
+    TIME_CURRENT="$(date --iso-8601=seconds)" ; # Produce `date`-parsable current timestamp with resolution of 1 second.
+    # Decide to parse current or supplied date
+    ## Check if time argument empty
+    if [[ -z "$argTime" ]]; then
+       ## T: Time argument empty, use current time
+       TIME_INPUT="$TIME_CURRENT";
+    else
+       ## F: Time argument exists, validate time
+       if date --date="$argTime" 1>/dev/null 2>&1; then
+           ### T: Time argument is valid; use it
+           TIME_INPUT="$argTime";
+       else
+           ### F: Time argument not valid; exit
+           yell "ERROR:Invalid time argument supplied. Exiting."; exit 1;
+       fi
+    fi
+    # Construct and deliver separator-les date string    
+    DATE_CURRENT_SHORT="$(date -d "$TIME_INPUT" +%Y%m%d)"; # Produce separator-less current date with resolution 1 day.
+    echo "$DATE_CURRENT_SHORT";
+} # Get YYYYmmdd
+timeDuration(){
+    # Desc: Given seconds, output ISO-8601 duration string
+    # Ref/Attrib: ISO-8601:2004(E), §4.4.4.2 Representations of time intervals by duration and context information
+    # Note: "1 month" ("P1M") is assumed to be "30 days" (see ISO-8601:2004(E), §2.2.1.2)
+    # Usage: timeDuration [1:seconds] ([2:precision])
+    # Version: 1.0.3
+    # Input: arg1: seconds as base 10 integer >= 0  (ex: 3601)
+    #        arg2: precision level (optional; default=2)
+    # Output: stdout: ISO-8601 duration string (ex: "P1H1S", "P2Y10M15DT10H30M20S")
+    #         exit code 0: success
+    #         exit code 1: error_input
+    #         exit code 2: error_unknown
+    # Example: 'timeDuration 111111 3' yields 'P1DT6H51M'
+    # Depends: date 8 (gnucoreutils), yell, 
+    local returnState argSeconds argPrecision remainder precision witherPrecision
+    local fullYears fullMonths fullDays fullHours fullMinutes fullSeconds
+    local displayYears displayMonths displayDays displayHours displayMinutes displaySeconds
+    local hasYears hasMonths hasDays hasHours hasMinutes hasSeconds
+    
+    argSeconds="$1"; # read arg1 (seconds)
+    argPrecision="$2"; # read arg2 (precision)
+    precision=2; # set default precision
+
+    # Check that between one and two arguments is supplied
+    if ! { [[ $# -ge 1 ]] && [[ $# -le 2 ]]; }; then
+       yell "ERROR:Invalid number of arguments:$# . Exiting.";
+       returnState="error_input"; fi
+
+    # Check that argSeconds provided
+    if [[ $# -ge 1 ]]; then
+       ## Check that argSeconds is a positive integer
+       if [[ "$argSeconds" =~ ^[[:digit:]]+$ ]]; then
+           :
+       else
+           yell "ERROR:argSeconds not a digit.";
+           returnState="error_input";
+       fi
+    else
+       yell "ERROR:No argument provided. Exiting.";
+       exit 1;
+    fi
+
+    # Consider whether argPrecision was provided
+    if  [[ $# -eq 2 ]]; then
+       # Check that argPrecision is a positive integer
+       if [[ "$argPrecision" =~ ^[[:digit:]]+$ ]] && [[ "$argPrecision" -gt 0 ]]; then
+       precision="$argPrecision";
+       else
+           yell "ERROR:argPrecision not a positive integer. (is $argPrecision ). Leaving early.";
+           returnState="error_input";
+       fi;
+    else
+       :
+    fi;
+    
+    remainder="$argSeconds" ; # seconds
+    ## Calculate full years Y, update remainder
+    fullYears=$(( remainder / (365*24*60*60) ));
+    remainder=$(( remainder - (fullYears*365*24*60*60) ));
+    ## Calculate full months M, update remainder
+    fullMonths=$(( remainder / (30*24*60*60) ));
+    remainder=$(( remainder - (fullMonths*30*24*60*60) ));
+    ## Calculate full days D, update remainder
+    fullDays=$(( remainder / (24*60*60) ));
+    remainder=$(( remainder - (fullDays*24*60*60) ));
+    ## Calculate full hours H, update remainder
+    fullHours=$(( remainder / (60*60) ));
+    remainder=$(( remainder - (fullHours*60*60) ));
+    ## Calculate full minutes M, update remainder
+    fullMinutes=$(( remainder / (60) ));
+    remainder=$(( remainder - (fullMinutes*60) ));
+    ## Calculate full seconds S, update remainder
+    fullSeconds=$(( remainder / (1) ));
+    remainder=$(( remainder - (remainder*1) ));
+    ## Check which fields filled
+    if [[ $fullYears -gt 0 ]]; then hasYears="true"; else hasYears="false"; fi
+    if [[ $fullMonths -gt 0 ]]; then hasMonths="true"; else hasMonths="false"; fi
+    if [[ $fullDays -gt 0 ]]; then hasDays="true"; else hasDays="false"; fi
+    if [[ $fullHours -gt 0 ]]; then hasHours="true"; else hasHours="false"; fi
+    if [[ $fullMinutes -gt 0 ]]; then hasMinutes="true"; else hasMinutes="false"; fi
+    if [[ $fullSeconds -gt 0 ]]; then hasSeconds="true"; else hasSeconds="false"; fi
+    
+    ## Determine which fields to display (see ISO-8601:2004 §4.4.3.2)
+    witherPrecision="false"
+    
+    ### Years
+    if $hasYears && [[ $precision -gt 0 ]]; then
+       displayYears="true";
+       witherPrecision="true";
+    else
+       displayYears="false";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+    
+    ### Months
+    if $hasMonths && [[ $precision -gt 0 ]]; then
+       displayMonths="true";
+       witherPrecision="true";
+    else
+       displayMonths="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayMonths="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Days
+    if $hasDays && [[ $precision -gt 0 ]]; then
+       displayDays="true";
+       witherPrecision="true";
+    else
+       displayDays="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayDays="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Hours
+    if $hasHours && [[ $precision -gt 0 ]]; then
+       displayHours="true";
+       witherPrecision="true";
+    else
+       displayHours="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayHours="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Minutes
+    if $hasMinutes && [[ $precision -gt 0 ]]; then
+       displayMinutes="true";
+       witherPrecision="true";
+    else
+       displayMinutes="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displayMinutes="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ### Seconds
+
+    if $hasSeconds && [[ $precision -gt 0 ]]; then
+       displaySeconds="true";
+       witherPrecision="true";
+    else
+       displaySeconds="false";
+    fi;
+    if $witherPrecision && [[ $precision -gt 0 ]]; then
+       displaySeconds="true";
+    fi;
+    if $witherPrecision; then ((precision--)); fi;
+
+    ## Determine whether or not the "T" separator is needed to separate date and time elements
+    if ( $displayHours || $displayMinutes || $displaySeconds); then
+       displayDateTime="true"; else displayDateTime="false"; fi
+    
+    ## Construct duration output string
+    OUTPUT="P"
+    if $displayYears; then
+       OUTPUT=$OUTPUT$fullYears"Y"; fi
+    if $displayMonths; then
+       OUTPUT=$OUTPUT$fullMonths"M"; fi
+    if $displayDays; then
+       OUTPUT=$OUTPUT$fullDays"D"; fi
+    if $displayDateTime; then
+       OUTPUT=$OUTPUT"T"; fi
+    if $displayHours; then
+       OUTPUT=$OUTPUT$fullHours"H"; fi
+    if $displayMinutes; then
+       OUTPUT=$OUTPUT$fullMinutes"M"; fi
+    if $displaySeconds; then
+       OUTPUT=$OUTPUT$fullSeconds"S"; fi
+
+    ## Output duration string to stdout
+    echo "$OUTPUT" && returnState="true";
+
+    #===Determine function return code===
+    if [ "$returnState" = "true" ]; then
+       return 0;
+    elif [ "$returnState" = "error_input" ]; then
+       yell "ERROR:input";
+       return 1;
+    else
+       yell "ERROR:Unknown";
+       return 2;
+    fi
+
+} # Get duration (ex: PT10M4S )
+displayMissing() {
+    # Desc: Displays missing apps, files, and dirs
+    # Usage: displayMissing
+    # Input: associative arrays: appRollCall, fileRollCall, dirRollCall
+    # Output: stderr messages
+    #==BEGIN Display errors==
+    #===BEGIN Display Missing Apps===
+    missingApps="Missing apps  :"
+    #for key in "${!appRollCall[@]}"; do echo "DEBUG:$key => ${appRollCall[$key]}"; done
+    for key in "${!appRollCall[@]}"; do
+       value="${appRollCall[$key]}"
+       if [ "$value" = "false" ]; then
+           #echo "DEBUG:Missing apps: $key => $value";
+           missingApps="$missingApps""$key "
+           appMissing="true"
+       fi
+    done
+    if [ "$appMissing" = "true" ]; then  # Only indicate if an app is missing.
+       echo "$missingApps" 1>&2;
+    fi
+    #===END Display Missing Apps===
+
+    #===BEGIN Display Missing Files===
+    missingFiles="Missing files:"
+    #for key in "${!fileRollCall[@]}"; do echo "DEBUG:$key => ${fileRollCall[$key]}"; done
+    for key in "${!fileRollCall[@]}"; do
+       value="${fileRollCall[$key]}"
+       if [ "$value" = "false" ]; then
+           #echo "DEBUG:Missing files: $key => $value";
+           missingFiles="$missingFiles""$key "
+           fileMissing="true"
+       fi
+    done
+    if [ "$fileMissing" = "true" ]; then  # Only indicate if an app is missing.
+       echo "$missingFiles" 1>&2;
+    fi
+    #===END Display Missing Files===
+
+    #===BEGIN Display Missing Directories===
+    missingDirs="Missing dirs:"
+    #for key in "${!dirRollCall[@]}"; do echo "DEBUG:$key => ${dirRollCall[$key]}"; done
+    for key in "${!dirRollCall[@]}"; do
+       value="${dirRollCall[$key]}"
+       if [ "$value" = "false" ]; then
+           #echo "DEBUG:Missing dirs: $key => $value";
+           missingDirs="$missingDirs""$key "
+           dirMissing="true"
+       fi
+    done
+    if [ "$dirMissing" = "true" ]; then  # Only indicate if an dir is missing.
+       echo "$missingDirs" 1>&2;
+    fi
+    #===END Display Missing Directories===
+
+    #==END Display errors==
+} # Display missing apps, files, dirs
+setScriptTTL() {
+    #Desc: Sets script TTL
+    #Usage: setScriptTTL arg1
+    #Input: arg1: "day" or "hour"
+    #Output: scriptTTL
+    #Depends: timeUntilNextHour or timeUntilNextDay
+    local ARG1
+    ARG1="$1"
+    if [[ "$ARG1" = "day" ]]; then
+           # Set script lifespan to end at start of next day
+       if ! scriptTTL="$(timeUntilNextDay)"; then
+           if [[ "$scriptTTL" -eq 0 ]]; then
+           ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+           else
+           yell "ERROR: timeUntilNextDay exit code $?"; exit 1;
+           fi;
+       fi;
+    elif [[ "$ARG1" = "hour" ]]; then
+       # Set script lifespan to end at start of next hour
+       if ! scriptTTL="$(timeUntilNextHour)"; then
+           if [[ "$scriptTTL" -eq 0 ]]; then
+               ((scriptTTL++)); # Add 1 because 0 would cause 'timeout' to never timeout.
+           else
+               yell "ERROR: timeUntilNextHour exit code $?"; exit 1;
+           fi;
+       fi;
+    else
+       yell "ERROR:Invalid argument for setScriptTTL function."; exit 1;
+    fi
+} # Seconds until next (day|hour).
+checkMakeTar() {
+    # Desc: Checks that a valid tar archive exists, creates one otherwise
+    # Usage: checkMakeTar [ path ]
+    # Version: 1.0.1
+    # Input: arg1: path of tar archive
+    # Output: exit code 0 : tar readable
+    #         exit code 1 : tar missing; created
+    #         exit code 2 : tar not readable; moved; replaced
+    # Depends: try, tar, date
+    local PATH_TAR returnFlag0 returnFlag1 returnFlag2
+    PATH_TAR="$1"
+
+    # Check if file is a valid tar archive
+    if tar --list --file="$PATH_TAR" 1>/dev/null 2>&1; then
+       ## T1: return success
+       returnFlag0="tar valid";
+    else
+       ## F1: Check if file exists
+       if [[ -f "$PATH_TAR" ]]; then
+           ### T: Rename file
+           try mv "$PATH_TAR" "$PATH_TAR""--broken--""$(date +%Y%m%dT%H%M%S)" && \
+               returnFlag1="tar moved";
+       else
+           ### F: -
+           :
+       fi
+       ## F2: Create tar archive, return 0
+       try tar --create --file="$PATH_TAR" --files-from=/dev/null && \
+           returnFlag2="tar created";
+    fi
+    
+    # Determine function return code
+    if [[ "$returnFlag0" = "tar valid" ]]; then
+       return 0;
+    elif [[ "$returnFlag2" = "tar created" ]] && ! [[ "$returnFlag1" = "tar moved" ]]; then
+       return 1; # tar missing so created
+    elif [[ "$returnFlag2" = "tar created" ]] && [[ "$returnFlag1" = "tar moved" ]]; then
+       return 2; # tar not readable so moved; replaced
+    fi
+} # checks if arg1 is tar; creates one otherwise
+appendArgTar(){
+    # Desc: Writes first argument to temporary file with arguments as options, then appends file to tar
+    # Usage: appendArgTar "$(echo "Data to be written.")" [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+    # Version: 1.0.2
+    # Input: arg1: data to be written
+    #        arg2: file name of file to be inserted into tar
+    #        arg3: tar archive path (must exist first)
+    #        arg4: temporary working dir
+    #        arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+    # Output: file written to disk
+    # Example: decrypt multiple large files in parallel
+    #          appendArgTar "$(cat /tmp/largefile1.gpg)" "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendArgTar "$(cat /tmp/largefile2.gpg)" "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendArgTar "$(cat /tmp/largefile3.gpg)" "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+    # Depends: bash 5
+
+    # Save function name
+    local FN="${FUNCNAME[0]}";
+    #yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+    
+    # Set file name
+    if ! [ -z "$2" ]; then FILENAME="$2"; else yell "ERROR:$FN:Not enough arguments."; exit 1; fi
+    
+    # Check tar path is a file
+    if [ -f "$3" ]; then TAR_PATH="$3"; else yell "ERROR:$FN:Tar archive arg not a file."; exit 1; fi
+       
+    # Check temp dir arg
+    if ! [ -z "$4" ]; then TMP_DIR="$4"; else yell "ERROR:$FN:No temporary working dir set."; exit 1; fi
+    
+    # Set command strings
+    if ! [ -z "$5" ]; then CMD1="$5"; else CMD1="tee /dev/null "; fi # command string 1
+    if ! [ -z "$6" ]; then CMD2="$6"; else CMD2="tee /dev/null "; fi # command string 2
+    if ! [ -z "$7" ]; then CMD3="$7"; else CMD3="tee /dev/null "; fi # command string 3
+    if ! [ -z "$8" ]; then CMD4="$8"; else CMD4="tee /dev/null "; fi # command string 4
+
+    # # Debug
+    # yell "DEBUG:STATUS:$FN:CMD1:$CMD1"
+    # yell "DEBUG:STATUS:$FN:CMD2:$CMD2"
+    # yell "DEBUG:STATUS:$FN:CMD3:$CMD3"
+    # yell "DEBUG:STATUS:$FN:CMD4:$CMD4"
+    # yell "DEBUG:STATUS:$FN:FILENAME:$FILENAME"
+    # yell "DEBUG:STATUS:$FN:TAR_PATH:$TAR_PATH"
+    # yell "DEBUG:STATUS:$FN:TMP_DIR:$TMP_DIR"
+    
+    # Write to temporary working dir
+    echo "$1" | $CMD1 | $CMD2 | $CMD3 | $CMD4 > "$TMP_DIR"/"$FILENAME";
+
+    # Append to tar
+    try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
+    #yell "DEBUG:STATUS:$FN:Finished appendArgTar()."
+} # Append Bash var to file appended to Tar archive
+appendFileTar(){
+    # Desc: Processes first file and then appends to tar
+    # Usage: appendFileTar [file path] [name of file to be inserted] [tar path] [temp dir] ([cmd1] [cmd2] [cmd3] [cmd4]...)
+    # Version: 1.0.1
+    # Input: arg1: path of file to be (processed and) written
+    #        arg2: name to use for file inserted into tar
+    #        arg3: tar archive path (must exist first)
+    #        arg4: temporary working dir
+    #        arg5+: command strings (ex: "gpsbabel -i nmea -f - -o kml -F - ")
+    # Output: file written to disk
+    # Example: decrypt multiple large files in parallel
+    #          appendFileTar /tmp/largefile1.gpg "largefile1" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendFileTar /tmp/largefile2.gpg "largefile2" $HOME/archive.tar /tmp "gpg --decrypt" &
+    #          appendFileTar /tmp/largefile3.gpg "largefile3" $HOME/archive.tar /tmp "gpg --decrypt" &
+    # Depends: bash 5
+
+    # Save function name
+    local FN="${FUNCNAME[0]}";
+    #yell "DEBUG:STATUS:$FN:Finished appendFileTar()."
+    
+    # Set file name
+    if ! [ -z "$2" ]; then FILENAME="$2"; else yell "ERROR:$FN:Not enough arguments."; exit 1; fi
+    # Check tar path is a file
+    if [ -f "$3" ]; then TAR_PATH="$3"; else yell "ERROR:$FN:Tar archive arg not a file."; exit 1; fi
+    # Check temp dir arg
+    if ! [ -z "$4" ]; then TMP_DIR="$4"; else yell "ERROR:$FN:No temporary working dir set."; exit 1; fi
+    # Set command strings
+    if ! [ -z "$5" ]; then CMD1="$5"; else CMD1="tee /dev/null "; fi # command string 1
+    if ! [ -z "$6" ]; then CMD2="$6"; else CMD2="tee /dev/null "; fi # command string 2
+    if ! [ -z "$7" ]; then CMD3="$7"; else CMD3="tee /dev/null "; fi # command string 3
+    if ! [ -z "$8" ]; then CMD4="$8"; else CMD4="tee /dev/null "; fi # command string 4
+    # # Debug
+    # yell "DEBUG:STATUS:$FN:CMD1:$CMD1"
+    # yell "DEBUG:STATUS:$FN:CMD2:$CMD2"
+    # yell "DEBUG:STATUS:$FN:CMD3:$CMD3"
+    # yell "DEBUG:STATUS:$FN:CMD4:$CMD4"
+    # yell "DEBUG:STATUS:$FN:FILENAME:$FILENAME"
+    # yell "DEBUG:STATUS:$FN:TAR_PATH:$TAR_PATH"
+    # yell "DEBUG:STATUS:$FN:TMP_DIR:$TMP_DIR"
+    
+    # Write to temporary working dir
+    cat "$1" | $CMD1 | $CMD2 | $CMD3 | $CMD4 > "$TMP_DIR"/"$FILENAME";
+
+    # Append to tar
+    try tar --append --directory="$TMP_DIR" --file="$TAR_PATH" "$FILENAME";
+    #yell "DEBUG:STATUS:$FN:Finished appendFileTar()."
+} # Append file to Tar archive
+magicWriteVersion() {
+    # Desc: Appends time-stamped VERSION to PATHOUT_TAR
+    # Usage: magicWriteVersion
+    # Version: 0.1.0
+    # Input: CONTENT_VERSION, FILEOUT_VERSION, PATHOUT_TAR, DIR_TMP
+    # Input: SCRIPT_VERSION, SCRIPT_URL, AGE_VERSION, AGE_URL, SCRIPT_HOSTNAME
+    # Output: appends tar PATHOUT_TAR
+    # Depends: dateTimeShort, appendArgTar
+    local CONTENT_VERSION pubKeyIndex
+    
+    # Set VERSION file name
+    FILEOUT_VERSION="$(dateTimeShort)..VERSION";
+
+    # Gather VERSION data in CONTENT_VERSION
+    CONTENT_VERSION="SCRIPT_VERSION=$SCRIPT_VERSION";
+    #CONTENT_VERSION="$CONTENT_VERSION""\\n";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""SCRIPT_NAME=$SCRIPT_NAME";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""SCRIPT_URL=$SCRIPT_URL";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""AGE_VERSION=$AGE_VERSION";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""AGE_URL=$AGE_URL";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""DATE=$(date --iso-8601=seconds)";
+    CONTENT_VERSION="$CONTENT_VERSION""\\n""HOSTNAME=$SCRIPT_HOSTNAME";
+    ## Add list of recipient pubkeys
+    for pubkey in "${recPubKeysValid[@]}"; do
+       ((pubKeyIndex++))
+       CONTENT_VERSION="$CONTENT_VERSION""\\n""PUBKEY_$pubKeyIndex=$pubkey";
+    done
+    ## Process newline escapes
+    CONTENT_VERSION="$(echo -e "$CONTENT_VERSION")"
+
+    # Write CONTENT_VERSION as file FILEOUT_VERSION and write-append to PATHOUT_TAR
+    appendArgTar "$CONTENT_VERSION" "$FILEOUT_VERSION" "$PATHOUT_TAR" "$DIR_TMP";
+    
+} # bkgpslog: write version data to PATHOUT_TAR via appendArgTar()
+magicGatherWriteBuffer() {
+    # Desc: bkgpslog-specific meta function for writing data to DIR_TMP then appending each file to PATHOUT_TAR
+    # Inputs: PATHOUT_TAR FILEOUT_{NMEA,GPX,KML} CMD_CONV_{NMEA,GPX,KML} CMD_{COMPRESS,ENCRYPT} DIR_TMP,
+    # Inputs: BUFFER_TTL bufferTTL_STR SCRIPT_HOSTNAME CMD_COMPRESS_SUFFIX CMD_ENCRYPT_SUFFIX
+    # Depends: yell, try, vbm, appendArgTar, tar
+    local FN="${FUNCNAME[0]}";
+    wait; # Wait to avoid collision with older magicWriteBuffer() instances (see https://www.tldp.org/LDP/abs/html/x9644.html )
+    # Create buffer file with unique name
+    PATHOUT_BUFFER="$DIR_TMP/buffer$SECONDS";
+    # Fill buffer
+    timeout "$BUFFER_TTL"s gpspipe -r -o "$PATHOUT_BUFFER" ;
+    timeBufferStart="$(dateTimeShort  "$(date --date="$BUFFER_TTL seconds ago")")"; # Note start time
+    vbm "DEBUG:STATUS:$FN:Started magicWriteBuffer().";
+    # Determine file paths (time is start of buffer period)
+    FILEOUT_BASENAME="$timeBufferStart""--""$bufferTTL_STR""..""$SCRIPT_HOSTNAME""_location" && vbm "STATUS:Set FILEOUT_BASENAME to:$FILEOUT_BASENAME";
+    ## Files saved to DIR_TMP
+    FILEOUT_NMEA="$FILEOUT_BASENAME".nmea"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_NMEA to:$FILEOUT_NMEA";
+    FILEOUT_GPX="$FILEOUT_BASENAME".gpx"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_GPX to:$FILEOUT_GPX";
+    FILEOUT_KML="$FILEOUT_BASENAME".kml"$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX" && vbm "STATUS:Set FILEOUT_KML to:$FILEOUT_KML";
+    PATHOUT_NMEA="$DIR_TMP"/"$FILEOUT_NMEA" && vbm "STATUS:Set PATHOUT_NMEA to:$PATHOUT_NMEA";
+    PATHOUT_GPX="$DIR_TMP"/"$FILEOUT_GPX" && vbm "STATUS:Set PATHOUT_GPX to:$PATHOUT_GPX";
+    PATHOUT_KML="$DIR_TMP"/"$FILEOUT_KML" && vbm "STATUS:Set PATHOUT_KML to:$PATHOUT_KML";
+    ## Files saved to disk (DIR_OUT)
+    ### one file per day (Ex: "20200731..hostname_location.[.gpx.gz].tar")
+    PATHOUT_TAR="$DIR_OUT"/"$(dateShort "$(date --date="$BUFFER_TTL seconds ago")")".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+       vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
+    # DEBUG: check vars
+    vbm "STATUS:DIR_TMP     :$DIR_TMP";
+    vbm "STATUS:PATHOUT_TAR :$PATHOUT_TAR";
+    vbm "STATUS:PATHOUT_NMEA:$PATHOUT_NMEA";
+    vbm "STATUS:PATHOUT_GPX:$PATHOUT_GPX";
+    vbm "STATUS:PATHOUT_KML:$PATHOUT_KML";
+    
+    
+    # Validate PATHOUT_TAR as tar.
+    checkMakeTar "$PATHOUT_TAR";
+    ## Add VERSION file if checkMakeTar had to create a tar (exited 1) or replace one (exited 2)
+    if [[ $? -eq 1 ]] || [[ $? -eq 2 ]]; then magicWriteVersion; fi
+
+    # Write bufferBash to PATHOUT_TAR
+    appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_NMEA" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_NMEA" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write NMEA data
+    appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_GPX" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_GPX" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write GPX file
+    appendFileTar "$PATHOUT_BUFFER" "$FILEOUT_KML" "$PATHOUT_TAR" "$DIR_TMP" "$CMD_CONV_KML" "$CMD_COMPRESS" "$CMD_ENCRYPT"; # Write KML file
+
+    # Remove secured chunks from DIR_TMP
+    rm "$PATHOUT_BUFFER" "$PATHOUT_NMEA" "$PATHOUT_GPX" "$PATHOUT_KML";
+    vbm "DEBUG:STATUS:$FN:Finished magicWriteBuffer().";
+} # write buffer to disk
+
 main() {
     processArguments "$@" # Process arguments.
-    if checkapp gpspipe && checkdir "$DIROUT"; then
-
-
-       # Determine script lifespan (note: exit if <= 0 since 'timeout' runs forever if provided "0s".
-       #if ! scriptTTL="$(timeUntilMidnight)"; then yell "ERROR: timeUntilMidnight exit code $?"; exit 1; fi 
-       scriptTTL="3600"; # DEBUG DEBUG DEBUG DEBUG
-        
-       # Determine buffer lifespan
-       bufferTTL="60";
-
-       # Record gps data until script lifespan ends
-       declare debugCounter; debugCounter="0"
-       while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
-           ((debugCounter++))
-           # Determine output file paths (time is start of buffer period)
-           FILEOUT_BASENAME="$(dateTimeShort)--P$(bufferTTL)S..""$SCRIPT_HOSTNAME""_location" ;
-           FILEOUT_NMEA="$FILEOUT_BASENAME".nmea ;
-           FILEOUT_GPX="$FILEOUT_BASENAME".gpx ;
-           FILEOUT_KML="$FILEOUT_BASENAME".kml ;
-           # Fill buffer
-           buffer="$(timeout "$bufferTTL""s" gpspipe -r)"; # Record gpspipe nmea data to buffer for bufferTTL seconds
-           # Process and save buffers
-           echo "$buffer"                                     > "$DIROUT"/"$FILEOUT_NMEA" & # Save NMEA format
-           echo "$buffer" | gpsbabel -i nmea -f - -o gpx -F - > "$DIROUT"/"$FILEOUT_GPX"  & # Save GPX format
-           echo "$buffer" | gpsbabel -i nmea -f - -o kml -F - > "$DIROUT"/"$FILEOUT_KML"  & # Save KML format
-           vbm "DEBUG:Completed buffer session $debugCounter ." 1>&2;
-           # Reset buffer and filenames
-           unset buffer buffer_GPX buffer_KML FILEOUT_BASENAME FILEOUT_NMEA FILEOUT_GPX FILEOUT_KML;
-       done
+    
+    # Determine working directory
+    ## Set DIR_TMP_PARENT to user-specified value if specified
+    if [[ "$OPTION_TMPDIR" = "true" ]]; then
+           if [[ -d "$TMP_DIR_PRIORITY" ]]; then
+           DIR_TMP_PARENT="$OPTION_TMPDIR"; 
+       else
+           yell "WARNING:Specified temporary working directory not valid:$OPTION_TMPDIR";
+           exit 1;
+       fi
+    fi
+
+    ## Set DIR_TMP_PARENT to default or fallback otherwise
+    if [[ -d "$DIR_TMP_DEFAULT" ]]; then
+       DIR_TMP_PARENT="$DIR_TMP_DEFAULT";
+    elif [[ -d /tmp ]]; then
+       yell "WARNING:/dev/shm not available. Falling back to /tmp .";
+       DIR_TMP_PARENT="/tmp";
+    else
+       yell "ERROR:No valid working directory available. Exiting.";
+       exit 1;
     fi
+
+    ## Set DIR_TMP using DIR_TMP_PARENT and nonce (SCRIPT_TIME_START)
+    DIR_TMP="$DIR_TMP_PARENT"/"$SCRIPT_TIME_START""..bkgpslog" && vbm "DEBUG:Set DIR_TMP to:$DIR_TMP"; # Note: removed at end of main().
+    
+    # Set output encryption and compression option strings
+    if [[ "$OPTION_ENCRYPT" = "true" ]]; then # Check if encryption option active.
+       if checkapp age; then # Check that age is available.
+           for pubkey in "${recPubKeys[@]}"; do # Validate recipient pubkey strings by forming test message
+               vbm "DEBUG:Testing pubkey string:$pubkey";
+               if echo "butts" | age -a -r "$pubkey" 1>/dev/null; then
+                   #### Form age recipient string
+                   recipients="$recipients""-r \"$pubkey\" ";
+                   vbm "STATUS:Added pubkey for forming age recipient string:""$pubkey";
+                   vbm "DEBUG:recipients:""$recipients";
+                   #### Add validated pubkey to recPubKeysValid array
+                   recPubKeysValid+=("$pubkey") && vbm "DEBUG:recPubkeysValid:pubkey added:$pubkey";
+               else
+                   yell "ERROR:Exit code ""$?"". Invalid recipient pubkey string. Exiting."; exit 1;
+               fi
+           done
+           vbm "DEBUG:Finished processing recPubKeys array";
+
+           ##  Form age command string
+           CMD_ENCRYPT="age ""$recipients ";
+           CMD_ENCRYPT_SUFFIX=".age";
+       else
+           yell "ERROR:Encryption enabled but \"age\" not found. Exiting."; exit 1;
+       fi
+    else
+       CMD_ENCRYPT="tee /dev/null ";
+       CMD_ENCRYPT_SUFFIX="";
+       vbm "DEBUG:Encryption not enabled."
+    fi
+    if [[ "$OPTION_COMPRESS" = "true" ]]; then # Check if compression option active
+       if checkapp gzip; then # Check if gzip available
+           CMD_COMPRESS="gzip ";
+           CMD_COMPRESS_SUFFIX=".gz";
+       else
+           yell "ERROR:Compression enabled but \"gzip\" not found. Exiting."; exit 1;
+       fi
+    else
+       CMD_COMPRESS="tee /dev/null ";
+       CMD_COMPRESS_SUFFIX="";
+       vbm "DEBUG:Compression not enabled.";
+    fi
+
+    # Check that critical apps and dirs are available, displag missing ones.
+    if ! checkapp gpspipe tar && ! checkdir "$DIR_OUT" "/dev/shm"; then
+       yell "ERROR:Critical components missing.";
+       displayMissing; yell "Exiting."; exit 1; fi
+
+    # Set script lifespan
+    setScriptTTL "$SCRIPT_TTL"; # seconds until next new SCRIPT_TTL (ex: "day" or "hour")
+
+    # File name substring: encoded bufferTTL
+    bufferTTL_STR="$(timeDuration $BUFFER_TTL)";
+
+    # Init temp working dir
+    try mkdir "$DIR_TMP" && vbm "DEBUG:Working dir creatd at:$DIR_TMP";
+
+    # Initialize 'tar' archive
+    ## Define output tar path (note: each day gets *one* tar file (Ex: "20200731..hostname_location.[.gpx.gz].tar"))
+    PATHOUT_TAR="$DIR_OUT"/"$(dateShort)".."$SCRIPT_HOSTNAME""_location""$CMD_COMPRESS_SUFFIX""$CMD_ENCRYPT_SUFFIX".tar && \
+       vbm "STATUS:Set PATHOUT_TAR to:$PATHOUT_TAR";
+    ## Check that PATHOUT_TAR is a tar. Rename old and create empty one otherwise.
+    checkMakeTar "$PATHOUT_TAR" && vbm "DEBUG:Confirmed or Created to be a tar:$PATHOUT_TAR";
+    ## Append VERSION file to PATHOUT_TAR
+    magicWriteVersion;
+
+    # Define GPS conversion commands
+    CMD_CONV_NMEA="tee /dev/null " && vbm "STATUS:Set CMD_CONV_NMEA to:$CMD_CONV_NMEA"; # tee as passthrough
+    CMD_CONV_GPX="gpsbabel -i nmea -f - -o gpx -F - " && vbm "STATUS:Set CMD_CONV_GPX to:$CMD_CONV_GPX"; # convert NMEA to GPX
+    CMD_CONV_KML="gpsbabel -i nmea -f - -o kml -F - " && vbm "STATUS:Set CMD_CONV_KML to:$CMD_CONV_KML"; # convert NMEA to KML
+
+    # MAIN LOOP:Record gps data until script lifespan ends
+    while [[ "$SECONDS" -lt "$scriptTTL" ]]; do
+       magicGatherWriteBuffer &
+       sleep "$BUFFER_TTL";
+    done    
+
+    # Cleanup
+    ## Remove DIR_TMP
+    try rm -r "$DIR_TMP";
+
+    vbm "STATUS:Main function finished.";
 } # Main function.
 #===END Declare local script functions===
 #==END Define script parameters==
@@ -266,7 +1010,3 @@ main() {
 main "$@" # Run main function.
 exit 0;
 #==END Perform work and exit==
-
-
-    
-    #gpspipe -r -d -l -o "$DIROUT1"/"$FILEOUT1" ;